if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

if(ttd2.frames == nil) then
	ttd2.frames = {}
end
local frames = ttd2.frames

frames.MainFrame = {}
local this = frames.MainFrame

function this.RefreshModules()
	--hide all existing buttons
	for _,Button in pairs(this.Buttons) do
		Button:Hide()
	end
	this.NumButtons = 0
	this.ScrollBar:SetMinMaxValues(0, 0)
	
	--ask modules to evaluate their status and add button accordingly	
	for _,m in pairs(ttd2.mod) do
		if((m.CheckStatus == nil) or (m.CheckStatus() == true)) then
			this.AddButton(m.Text, m.Script)
		end
	end
	return
end

function this.CreateOptionsFrame()

	this.OptionsTitle				= nil
	this.OptionsCloseButton 		= nil
	this.CompletedCB				= nil
	this.DoneCB						= nil
	this.TomTomCB					= nil
	this.CharacterAchCB				= nil
	this.ParagonEmissaryCB			= nil
	this.RareSourcesCB				= nil
	this.AchCompletionistCB			= nil
	this.TransmogCompletionistCB	= nil
	this.PetCompletionistCB			= nil
	this.GoldenCagesCB				= nil
	
	--options frame	
	this.OptionsFrame = CreateFrame("Frame", "TTD2Optionsframe", this.ParentFrame)
	this.OptionsFrame:SetSize(250, 500)
	this.OptionsFrame:SetPoint("TOPLEFT", 260, 0)
	
	local border=this.OptionsFrame:CreateTexture(nil,"BACKGROUND")
	border:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	border:SetPoint("TOPLEFT",-5,5)
	border:SetPoint("BOTTOMRIGHT",5,-5)
	border:SetVertexColor(0.85, 0.85, 0.85, .5) 
	
	local body = this.OptionsFrame:CreateTexture(nil, "ARTWORK")
	body:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	body:SetAllPoints(this.OptionsFrame)
	body:SetVertexColor(0.1, 0.1, 0.1, 1.0)
	
	this.OptionsFrame:SetMovable(true)
	this.OptionsFrame:EnableMouse(true)
	this.OptionsFrame:RegisterForDrag("LeftButton")
	this.OptionsFrame:SetScript("OnDragStart", this.OptionsFrame.StartMoving)
	this.OptionsFrame:SetScript("OnDragStop", this.OptionsFrame.StopMovingOrSizing)
	
	--title
	this.OptionsTitle = this.OptionsFrame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	this.OptionsTitle:SetPoint("TOP", -10, -5)
	this.OptionsTitle:SetText(ttd2.lib.chat.addonTitle())
	
	--close button
	this.OptionsCloseButton = CreateFrame("Button", nil, this.OptionsFrame, "UIPanelButtonTemplate")
	this.OptionsCloseButton:SetPoint("TOPRIGHT", 0, 0)
	this.OptionsCloseButton:SetSize(25,25)
	this.OptionsCloseButton:SetText("x")
	this.OptionsCloseButton:SetScript("OnClick", this.ToggleOptions)
	
	local PosY = -30
	local Spacing = -20
	--completed checkbox
	this.CompletedCB = CreateFrame("CheckButton", "TTD2_COMPLETED_CHECKBOX", this.OptionsFrame, "ChatConfigCheckButtonTemplate")
	this.CompletedCB:SetPoint("TOPLEFT", 15, PosY)
	TTD2_COMPLETED_CHECKBOXText:SetText("include "..lib.chat.green("completed"))
	this.CompletedCB.tooltip = "Print entries that have been completed permanently."
	this.CompletedCB:SetScript("OnClick", ttd2.option.ToggleCompleted)
	this.CompletedCB:SetChecked(ttd2.option.PrintCompleted)
	PosY = PosY + Spacing
	
	--done checkbox
	this.DoneCB = CreateFrame("CheckButton", "TTD2_DONE_CHECKBOX", this.OptionsFrame, "ChatConfigCheckButtonTemplate")
	this.DoneCB:SetPoint("TOPLEFT", 15, PosY)
	TTD2_DONE_CHECKBOXText:SetText("include "..lib.chat.red("done"))
	this.DoneCB.tooltip = "Print entries that are not part of achievements/collections or have already been attempted and you now have lockout ID for them.\nAlso used if a required WQ is not up."
	this.DoneCB:SetScript("OnClick", ttd2.option.ToggleDone)
	this.DoneCB:SetChecked(ttd2.option.PrintDone)
	PosY = PosY + Spacing
	
	--rare sources
	this.RareSourcesCB = CreateFrame("CheckButton", "TTD2_RARESOURCES_CHECKBOX", this.OptionsFrame, "ChatConfigCheckButtonTemplate")
	this.RareSourcesCB:SetPoint("TOPLEFT", 15, PosY)
	TTD2_RARESOURCES_CHECKBOXText:SetText("include "..lib.chat.purple("rare"))
	this.RareSourcesCB.tooltip = "Rare sources are not usually available and may require extensive time camping/searching them. Check this box if you want to include them."
	this.RareSourcesCB:SetScript("OnClick", ttd2.option.ToggleRareSources)
	this.RareSourcesCB:SetChecked(ttd2.option.RareSources)
	PosY = PosY + Spacing
	
	--tomtom checkbox
	this.TomTomCB = CreateFrame("CheckButton", "TTD2_TOMTOM_CHECKBOX", this.OptionsFrame, "ChatConfigCheckButtonTemplate")
	this.TomTomCB:SetPoint("TOPLEFT", 15, PosY)
	TTD2_TOMTOM_CHECKBOXText:SetText("verbose TomTom output")
	this.TomTomCB.tooltip = "Print very verbose TomTom messages/links that will tell you exactly which continent/zone your target is in - this may clutter your chat if you are only interested in the waypoint."
	this.TomTomCB:SetScript("OnClick", ttd2.option.ToggleTomTom)
	this.TomTomCB:SetChecked(ttd2.option.VerboseTomTom)
	PosY = PosY + Spacing
	
	--new options!
	
	--character achievements
	this.CharacterAchCB = CreateFrame("CheckButton", "TTD2_CHARACTERACHIEVEMENTS_CHECKBOX", this.OptionsFrame, "ChatConfigCheckButtonTemplate")
	this.CharacterAchCB:SetPoint("TOPLEFT", 15, PosY)
	TTD2_CHARACTERACHIEVEMENTS_CHECKBOXText:SetText("character achievements")
	this.CharacterAchCB.tooltip = "Consider achievements incomplete until the current character has earned them."
	this.CharacterAchCB:SetScript("OnClick", ttd2.option.ToggleCharacterAchievements)
	this.CharacterAchCB:SetChecked(ttd2.option.CharacterAchievements)
	PosY = PosY + Spacing
	
	--paragon without emissary
	this.ParagonEmissaryCB = CreateFrame("CheckButton", "TTD2_PARAGONEMISSARY_CHECKBOX", this.OptionsFrame, "ChatConfigCheckButtonTemplate")
	this.ParagonEmissaryCB:SetPoint("TOPLEFT", 15, PosY)
	TTD2_PARAGONEMISSARY_CHECKBOXText:SetText("paragon without emissary")
	this.ParagonEmissaryCB.tooltip = "By default, missing paragon-rewards are only listed if the associate emissary is available. Check this box to always list missing paragon-rewards."
	this.ParagonEmissaryCB:SetScript("OnClick", ttd2.option.ToggleParagonEmissary)
	this.ParagonEmissaryCB:SetChecked(ttd2.option.ParagonEmissary)
	PosY = PosY + Spacing
	
	--ach completionist
	this.AchCompletionistCB = CreateFrame("CheckButton", "TTD2_ACHCOMPLETIONIST_CHECKBOX", this.OptionsFrame, "ChatConfigCheckButtonTemplate")
	this.AchCompletionistCB:SetPoint("TOPLEFT", 15, PosY)
	TTD2_ACHCOMPLETIONIST_CHECKBOXText:SetText("ach. completionist")
	this.AchCompletionistCB.tooltip = "If achievements only require x out of y criteria to complete, still list missing criteria even after the achievement has been earned."
	this.AchCompletionistCB:SetScript("OnClick", ttd2.option.ToggleAchCompletionist)
	this.AchCompletionistCB:SetChecked(ttd2.option.AchCompletionist)
	PosY = PosY + Spacing
	
	--transmog completionist
	this.TransmogCompletionistCB = CreateFrame("CheckButton", "TTD2_TRANSMOGCOMPLETIONIST_CHECKBOX", this.OptionsFrame, "ChatConfigCheckButtonTemplate")
	this.TransmogCompletionistCB:SetPoint("TOPLEFT", 15, PosY)
	TTD2_TRANSMOGCOMPLETIONIST_CHECKBOXText:SetText("transmog completionist")
	this.TransmogCompletionistCB.tooltip = "Show Transmog-Items as missing even after you have earned the appearance from another item."
	this.TransmogCompletionistCB:SetScript("OnClick", ttd2.option.ToggleTransmogCompletionist)
	this.TransmogCompletionistCB:SetChecked(ttd2.option.TransmogCompletionist)
	PosY = PosY + Spacing
	
	--pet completionist
	this.PetCompletionistCB = CreateFrame("CheckButton", "TTD2_PETCOMPLETIONIST_CHECKBOX", this.OptionsFrame, "ChatConfigCheckButtonTemplate")
	this.PetCompletionistCB:SetPoint("TOPLEFT", 15, PosY)
	TTD2_PETCOMPLETIONIST_CHECKBOXText:SetText("pet completionist")
	this.PetCompletionistCB.tooltip = "Treat pets as incomplete until you own the maximum amount of them (usually 3/3)."
	this.PetCompletionistCB:SetScript("OnClick", ttd2.option.TogglePetCompletionist)
	this.PetCompletionistCB:SetChecked(ttd2.option.PetCompletionist)
	PosY = PosY + Spacing
	
	--golden cages
	this.GoldenCagesCB = CreateFrame("CheckButton", "TTD2_GOLDENCAGES_CHECKBOX", this.OptionsFrame, "ChatConfigCheckButtonTemplate")
	this.GoldenCagesCB:SetPoint("TOPLEFT", 15, PosY)
	TTD2_GOLDENCAGES_CHECKBOXText:SetText("golden cages")
	this.GoldenCagesCB.tooltip = "Always consider cageable pets as incomplete."
	this.GoldenCagesCB:SetScript("OnClick", ttd2.option.ToggleGoldenCages)
	this.GoldenCagesCB:SetChecked(ttd2.option.GoldenCages)
	PosY = PosY + Spacing

	
	this.OptionsFrame:Hide()
	
	return
end

function this.Create()

	this.ParentFrame 		= nil
	this.Title				= nil
	this.CloseButton 		= nil
	this.ScrollFrame 		= nil
	this.ScrollBar			= nil
	this.ContentFrame		= nil
	this.OptionsButton		= nil
	this.RefreshButtonFrame	= nil
	this.ButtonSizeX		= 200
	this.ButtonSizeY		= 50
	this.NumButtons 		= 0
	this.NumButtonsCap		= 7
	this.Buttons = {}
	this.IgnoredModules = {}

	--parent frame	
	this.ParentFrame = CreateFrame("Frame", "TTD2Mainframe", UIParent)
	this.ParentFrame:SetSize(250, 500)
	this.ParentFrame:SetPoint("TOPLEFT", 10, -150)
	
	tinsert(UISpecialFrames, "TTD2Mainframe")
	
	local border=this.ParentFrame:CreateTexture(nil,"BACKGROUND")
	border:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	border:SetPoint("TOPLEFT",-5,5)
	border:SetPoint("BOTTOMRIGHT",5,-5)
	border:SetVertexColor(0.85, 0.85, 0.85, .5) 
	
	local body = this.ParentFrame:CreateTexture(nil, "ARTWORK")
	body:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	body:SetAllPoints(this.ParentFrame)
	body:SetVertexColor(0.1, 0.1, 0.1, 1.0)
	
	this.ParentFrame:SetMovable(true)
	this.ParentFrame:EnableMouse(true)
	this.ParentFrame:RegisterForDrag("LeftButton")
	this.ParentFrame:SetScript("OnDragStart", this.ParentFrame.StartMoving)
	this.ParentFrame:SetScript("OnDragStop", this.ParentFrame.StopMovingOrSizing)
	
	--title
	this.Title = this.ParentFrame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	this.Title:SetPoint("TOP", -10, -5)
	this.Title:SetText(ttd2.lib.chat.addonTitle().." v"..GetAddOnMetadata("ThingsToDo2","Version"))
	
	--close button
	this.CloseButton = CreateFrame("Button", nil, this.ParentFrame, "UIPanelButtonTemplate")
	this.CloseButton:SetPoint("TOPRIGHT", 0, 0)
	this.CloseButton:SetSize(25,25)
	this.CloseButton:SetText("x")
	this.CloseButton:SetScript("OnClick", this.ToggleMain)
	
	--options button
	this.OptionsButton = CreateFrame("Button", nil, this.ParentFrame, "UIPanelButtonTemplate")
	this.OptionsButton:SetPoint("TOP", 0, -30)
	this.OptionsButton:SetSize(this.ButtonSizeX,this.ButtonSizeY)
	this.OptionsButton:SetText("Options")
	this.OptionsButton:SetScript("OnClick", this.ToggleOptions)
	
	--refresh button
	this.RefreshButton = CreateFrame("Button", nil, this.ParentFrame, "UIPanelButtonTemplate")
	this.RefreshButton:SetPoint("TOP", 0, -90)
	this.RefreshButton:SetSize(this.ButtonSizeX,this.ButtonSizeY)
	this.RefreshButton:SetText("Refresh Modules")
	this.RefreshButton:RegisterForClicks("LeftButtonUp", "RightButtonUp")
	this.RefreshButton:SetScript("OnClick", function(self,button,down)
		if(button == "RightButton") then
			lib.table.clear(this.IgnoredModules)
		end
		this.RefreshModules()
	end)
	
	--scrollframe
	this.ScrollFrame = CreateFrame("ScrollFrame", nil, this.ParentFrame)
	this.ScrollFrame:SetPoint("TOPLEFT", this.ParentFrame, "TOPLEFT", 10, -145)
	this.ScrollFrame:SetPoint("BOTTOMRIGHT", this.ParentFrame, "BOTTOMRIGHT", -30, 10)
	--local texture = this.ScrollFrame:CreateTexture()
	--texture:SetAllPoints()
	--texture:SetColorTexture(.5,.5,.5,1)
	this.ParentFrame.scrollframe = this.ScrollFrame

	--scrollbar
	this.ScrollBar = CreateFrame("Slider", nil, this.ScrollFrame, "UIPanelScrollBarTemplate")
	this.ScrollBar:SetPoint("TOPRIGHT", this.ParentFrame, "TOPRIGHT", 0, -155)
	this.ScrollBar:SetPoint("BOTTOMRIGHT", this.ParentFrame, "BOTTOMRIGHT", 0, 20)
	this.ScrollBar:SetMinMaxValues(0, 0)
	this.ScrollBar:SetOrientation('VERTICAL')
	this.ScrollBar:SetValueStep(1)
	this.ScrollBar.scrollStep = 1
	this.ScrollBar:SetValue(0)
	this.ScrollBar:SetWidth(25)
	this.ScrollBar:SetScript(
		"OnValueChanged",
		function (self, value)
		self:GetParent():SetVerticalScroll(value)
		end)
	local scrollbg = this.ScrollBar:CreateTexture(nil, "BACKGROUND")
	scrollbg:SetAllPoints(this.ScrollBar)
	scrollbg:SetColorTexture(0, 0, 0, 0.4)
	this.ParentFrame.scrollbar = this.ScrollBar
	
	--content frame
	this.ContentFrame = CreateFrame("Frame", nil, this.ScrollFrame)
	this.ContentFrame:SetSize(210, 1050)
	this.ScrollFrame.content = this.ContentFrame
	this.ScrollFrame:SetScrollChild(this.ContentFrame)
	
	this.ParentFrame:Hide()
	
	this.ParentFrame:EnableMouseWheel(1)
	this.ParentFrame:SetScript(
		"OnMouseWheel",
		function (self, value)
			local ScrollMin, ScrollMax = this.ScrollBar:GetMinMaxValues();
			local ScrollStep = (ScrollMax - ScrollMin) / 20.0
			this.ScrollBar:SetValue(this.ScrollBar:GetValue()-(value*ScrollStep))
			end)
			
	this.CreateOptionsFrame()
	
	return;
end

function this.AddModuleButton(ModuleButton)
	if(ModuleButton.Frame == nil) then
		ModuleButton.Frame = CreateFrame("Button", nil, this.ContentFrame, "UIPanelButtonTemplate")
	end
	
	local Button = ModuleButton.Frame
	
	Button:SetPoint("TOP", 0, -this.ButtonSizeY*this.NumButtons)
	Button:SetSize(this.ButtonSizeX,this.ButtonSizeY)
	Button:SetText(ModuleButton.Text)
	
	Button:RegisterForClicks("LeftButtonUp", "RightButtonUp")
	Button:SetScript("OnClick", ModuleButton.Script)
	
	this.NumButtons = this.NumButtons + 1
	if(this.NumButtons > this.NumButtonsCap) then
		local ScrollMin, ScrollMax = this.ScrollBar:GetMinMaxValues();
		this.ScrollBar:SetMinMaxValues(ScrollMin, ScrollMax+this.ButtonSizeY)
	end

	return
end


function this.AddButton(Text, Script)
	--check if this module is ignored
	if(this.IgnoredModules[Text] == true) then
		return
	end
	
	--try and reuse existing button frames
	if(this.Buttons[this.NumButtons+1] == nil) then
		this.Buttons[this.NumButtons+1] = CreateFrame("Button", nil, this.ContentFrame, "UIPanelButtonTemplate")
	else
		this.Buttons[this.NumButtons+1]:Show()
	end
	local Button = this.Buttons[this.NumButtons+1]
	
	Button:SetPoint("TOP", 0, -this.ButtonSizeY*this.NumButtons)
	Button:SetSize(this.ButtonSizeX,this.ButtonSizeY)
	Button:SetText((this.NumButtons + 1)..": "..Text)
	Button:RegisterForClicks("LeftButtonUp", "RightButtonUp")
	Button:SetScript("OnClick", function(self,button,down)
		if(button == "RightButton") then
			this.IgnoredModules[Text] = true
			self:Hide()
		else
			Script()
		end
	end)
	
	this.NumButtons = this.NumButtons + 1
	if(this.NumButtons > this.NumButtonsCap) then
		local ScrollMin, ScrollMax = this.ScrollBar:GetMinMaxValues();
		this.ScrollBar:SetMinMaxValues(ScrollMin, ScrollMax+this.ButtonSizeY)
	end
	
	return
end

function this.ToggleMain()
	if(this.ParentFrame:IsVisible()) then
		this.ParentFrame:Hide()
	else
		this.ParentFrame:Show()
	end
	
	return;
end

function this.ToggleOptions()
	if(this.OptionsFrame:IsVisible()) then
		this.OptionsFrame:Hide()
	else
		this.OptionsFrame:Show()
	end
	
	return;
end
