if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.mod == nil) then
	ttd2.mod = {}
end
local mod = ttd2.mod

--this module
ttd2.BFAIslandStatus = {}
local this = ttd2.BFAIslandStatus
this.Name = "[BFA] Island-Status"

this.private = { set = false }
function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
		this.private.set = true
	end
	
	return
end

function this.private.Init()
	if(this.private.set == true) then
		return
	end
	
	this.private.quest = nil
	
	this.private.MyLevel = lib.unit.GetPlayerLevel()
	if(this.private.MyLevel < 120) then
		return
	end
	
	local MyFaction = lib.unit.GetPlayerFaction()
	if(MyFaction == "Alliance") then
		this.private.quest = 53436
	elseif(MyFaction == "Horde") then
		this.private.quest = 53435
	end
	
	lib.quest.AddByID(this.private.quest,true)
	
	return
end

function this.private.Update()
	this.private.Validate()
	
	local out = lib.chat.output
	out.ClearBuffer()
	
	if(this.private.MyLevel < 120) then
		return
	end
	
	lib.quest.UpdateByID(this.private.quest)
	local Quest = lib.quest.GetByID(this.private.quest)
	
	if(Quest.IsCompleted == true) then
		out.StoreCompleted(Quest.Link)
	else
		out.StoreTodo(Quest.Objectives[1].Text)
		if(Quest.Objectives[1].IsCompleted == true) then
			out.StoreTodo("Hand in "..Quest.Link)
		end
	end
	
	return
end

function this.CheckStatus()
	this.private.Validate()
	
	this.private.Update()
	if(lib.chat.output.GetNumLines() == 0) then
		return false
	end
	
	return true
end

function this.Script()
	this.private.Validate()
	
	this.private.Update()
	lib.chat.output.PrintModule(this.Name)
	
	return
end

mod[#mod+1] =
{
	CheckStatus	= this.CheckStatus,
	Text		= this.Name,
	Script		= this.Script
}
