if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.mod == nil) then
	ttd2.mod = {}
end
local mod = ttd2.mod

--this module
ttd2.BFAParagon = {}
local this = ttd2.BFAParagon
this.Name = "[BFA] Paragon"

this.private = { set = false }
function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
		this.private.set = true
	end
	
	return
end

function this.private.Init()
	if(this.private.set == true) then
		return
	end
	
	--it may be possible to get exalted with one-time-quests at some point, so we will only require 110
	local MyLevel = lib.unit.GetPlayerLevel()
	if(MyLevel < 110) then
		return
	end
	
	local AllBFAParagon =
	{
		["Neutral"] =
		{			
			["Tortollan Seekers"] =
			{
				FactionID	= 2163,
				EmissaryID	= 50604,
				BoxID		= 166245,
				Rewards		=
				{
					{ Type = "Toy",		ItemID = 166704 },						--Bowl of Glowing Pufferfish
					{ Type = "Toy",		ItemID = 166851 },						--Kojo's Master Matching Set
					{ Type = "Recipe",	ItemID = 166264, ProfessionID = 185 }	--Recipe: Sanguinated Feast
				}
			},
			["Champions of Azeroth"] =
			{
				FactionID	= 2164,
				EmissaryID	= 50562,
				BoxID		= 166298,
				Rewards		=
				{
					{ Type = "Toy",		ItemID = 166877 }						--Azerite Firework Launcher
				}
			}
		},
		["Alliance"] =
		{
			["7th Legion"] =
			{
				FactionID	= 2159,
				EmissaryID	= 50605,
				BoxID		= 166300,
				Rewards		=
				{
					{ Type = "Toy",		ItemID = 166879 },						--Rallying War Banner
					{ Type = "Recipe",	ItemID = 166279, ProfessionID = 773 }	--Recipe: Contract: 7th Legion
				}
			},
			["Proudmoore Admiralty"] =
			{
				FactionID	= 2160,
				EmissaryID	= 50599,
				BoxID		= 166295,
				Rewards		=
				{
					{ Type = "Toy",		ItemID = 166702 },						--Proudmoore Music Box
					{ Type = "Pet",		ItemID = 166714, SpeciesID = 2566 }		--Albatross Feather
				}
			},
			["Order of Embers"] =
			{
				FactionID	= 2161,
				EmissaryID	= 50600,
				BoxID		= 166297,
				Rewards		=
				{
					{ Type = "Toy",		ItemID = 166808 },						--Bewitching Tea Set
					{ Type = "Pet",		ItemID = 166718, SpeciesID = 2568 }		--Cobalt Raven Hatchling
				}
			},
			["Storm's Wake"] =
			{
				FactionID	= 2162,
				EmissaryID	= 50601,
				BoxID		= 166294,
				Rewards		=
				{
					{ Type = "Recipe",	ItemID = 166665, ProfessionID = 773 },	--Technique: Glyph of Storm's Wake
					{ Type = "Pet",		ItemID = 166719, SpeciesID = 2569 }		--Cobalt Raven Hatchling
				}
			}
		},
		["Horde"] =
		{
			["Talanji's Expedition"] =
			{
				FactionID	= 2156,
				EmissaryID	= 50602,
				BoxID		= 166282,
				Rewards		=
				{
					{ Type = "Toy",		ItemID = 166308 },						--For da Blood God!
					{ Type = "Pet",		ItemID = 166716, SpeciesID = 2567 }		--Pair of Tiny Bat Wings
				}
			},
			["The Honorbound"] =
			{
				FactionID	= 2157,
				EmissaryID	= 50606,
				BoxID		= 166299,
				Rewards		=
				{
					{ Type = "Toy",		ItemID = 166879 },						--Rallying War Banner
					{ Type = "Recipe",	ItemID = 166311, ProfessionID = 773 }	--Recipe: Contract: The Honorbound
				}
			},
			["Voldunai"] =
			{
				FactionID	= 2158,
				EmissaryID	= 50603,
				BoxID		= 166290,
				Rewards		=
				{
					{ Type = "Toy",		ItemID = 165021 },						--Words of Akunda
					{ Type = "Toy",		ItemID = 166703 },						--Goldtusk Inn Breakfast Buffet
					{ Type = "Toy",		ItemID = 166880 }						--Meerah's Jukebox
				}
			},
			["Zandalari Empire"] =
			{
				FactionID	= 2103,
				EmissaryID	= 50598,
				BoxID		= 166292,
				Rewards		=
				{
					{ Type = "Toy",		ItemID = 166701 }						--Warbeast Kraal Dinner Bell
				}
			}
		}
	}
	
	local function TransferData(From, To)
		for _,Faction in pairs(From) do
			To[Faction.FactionID] =
			{
				EmissaryID	= Faction.EmissaryID,
				BoxID		= Faction.BoxID,
				Rewards		= {}
			}
			for _,Reward in pairs(Faction.Rewards) do
				To[Faction.FactionID].Rewards[Reward.ItemID] =
				{
					Type			= Reward.Type,
					ProfessionID	= Reward.ProfessionID,
					SpeciesID		= Reward.SpeciesID
				}
			end
		end
		return
	end
	
	local MyFaction = lib.unit.GetPlayerFaction()
	if(MyFaction == "Neutral") then
		this.private.Factions = {}
		TransferData(AllBFAParagon["Neutral"], this.private.Factions)
	elseif(MyFaction == "Alliance") then
		this.private.Factions = {}
		TransferData(AllBFAParagon["Neutral"], this.private.Factions)
		TransferData(AllBFAParagon["Alliance"], this.private.Factions)
	elseif(MyFaction == "Horde") then
		this.private.Factions = {}
		TransferData(AllBFAParagon["Neutral"], this.private.Factions)
		TransferData(AllBFAParagon["Horde"], this.private.Factions)
	else
		--in case some strange panda-wannabe ever tries this in the future...
		lib.chat.error(this.Name..": invalid player faction: "..MyFaction)
	end
	
	--init journal + item links
	for FactionID,FactionData in pairs(this.private.Factions) do
		lib.faction.AddByID(FactionID)
		lib.quest.AddByID(FactionData.EmissaryID)
		lib.item.AddByID(FactionData.BoxID)
		
		for ItemID,RewardData in pairs(FactionData.Rewards) do
		
			--we always need the item
			lib.item.AddByID(ItemID)
			
			if(RewardData.Type == "Toy") then
				lib.journal.toy.AddByID(ItemID)
			elseif(RewardData.Type == "Pet") then
				lib.journal.pet.AddByID(RewardData.SpeciesID)
			elseif(RewardData.Type == "Recipe") then
				--nothing to do here
			else
				lib.chat.error(this.Name..": invalid reward type: "..RewardData.Type)
			end
		end
	end
	
	this.private.Missing = {}
	
	return
end

function this.private.UpdateReward(ItemID, RewardData)
	this.private.Validate()
	
	RewardData.IsCollected = false
	
	if(RewardData.Type == "Toy") then
		RewardData.IsCollected = lib.journal.toy.GetByID(ItemID).IsCollected
	elseif(RewardData.Type == "Pet") then
		RewardData.IsCollected = lib.journal.pet.GetByID(RewardData.SpeciesID).IsCollected
	elseif(RewardData.Type == "Recipe") then
		--this is a little more complicated :)
		if(lib.professions.DoesCharacterHaveProfession(RewardData.ProfessionID) == true) then
			RewardData.IsLearnable			= true
			if(lib.recipe.IsRecipeInfoAvailable(ItemID) == true) then
				RewardData.IsLoading		= false
				if(lib.recipe.IsRecipeLearned(ItemID) == true) then
					RewardData.IsCollected	= true
				else
					RewardData.IsCollected	= false
				end
			else
				RewardData.IsLoading		= true
				RewardData.IsCollected		= false
			end
		else
			RewardData.IsLearnable			= false
			RewardData.IsLoading			= false
			RewardData.IsCollected			= true
		end
	else
		lib.chat.error(this.Name..": invalid reward type: "..RewardData.Type)
	end
	
	return
end

function this.private.UpdateFaction(FactionID, FactionData)
	this.private.Validate()

	--in this faction we will only loop over all the data and set flags that will subsequentially used for output.
	if(lib.faction.GetByID(FactionID).Paragon == nil) then
		FactionData.RewardPending			= false
		FactionData.CurrentRep				= 0
		FactionData.RepNext					= 0
		FactionData.RepStatus				= " "
	else
		FactionData.RewardPending			= lib.faction.GetByID(FactionID).Paragon.HasRewardPending
		FactionData.CurrentRep				= lib.faction.GetByID(FactionID).Paragon.CurrentRep
		FactionData.RepNext					= lib.faction.GetByID(FactionID).Paragon.NextRep
		while(FactionData.CurrentRep > FactionData.RepNext) do
			FactionData.CurrentRep			= FactionData.CurrentRep - FactionData.RepNext
		end
		FactionData.RepStatus				= " ("..FactionData.CurrentRep.." / " ..FactionData.RepNext..")"
	end
	
	FactionData.Name						= lib.faction.GetByID(FactionID).Name
	FactionData.RewardLink					= lib.item.GetByID(FactionData.BoxID).Link
	FactionData.SomethingMissing			= false
	FactionData.EmissaryActive				= lib.quest.GetByID(FactionData.EmissaryID).IsInLog
	FactionData.EmissaryLink				= lib.quest.GetByID(FactionData.EmissaryID).Link
	FactionData.EmissaryTimeLeft			= lib.quest.GetByID(FactionData.EmissaryID).TimeLeftString
	
	if(FactionData.EmissaryActive == true) then
		FactionData.EmissaryMessage = FactionData.EmissaryLink
		if(FactionData.RepNext ~= 0) then
			FactionData.EmissaryMessage = FactionData.EmissaryMessage..FactionData.RepStatus
		end
		FactionData.EmissaryMessage = FactionData.EmissaryMessage.." "..FactionData.EmissaryTimeLeft
	else
		FactionData.EmissaryMessage = FactionData.Name
	end
	
	for ItemID,RewardData in pairs(FactionData.Rewards) do
		this.private.UpdateReward(ItemID,RewardData)
		if(RewardData.IsCollected == false) then
			FactionData.SomethingMissing	= true
		end
	end
	
	return
end

function this.private.PrintReward(ItemID, RewardData, NCOFunction)
	this.private.Validate()
	
	if((RewardData.Type == "Toy") or (RewardData.Type == "Pet")) then
		if(RewardData.IsCollected == true) then
			lib.chat.output.StoreCompleted(lib.item.GetByID(ItemID).Link)
		else
			NCOFunction(lib.item.GetByID(ItemID).Link)
		end
	elseif(RewardData.Type == "Recipe") then
		if(RewardData.IsLearnable == true) then
			if(RewardData.IsLoading == true) then
				NCOFunction(lib.item.GetByID(ItemID).Link.." - Loading item information. Please wait a few seconds and refresh.")
			else
				if(RewardData.IsCollected == true) then
					lib.chat.output.StoreCompleted(lib.item.GetByID(ItemID).Link)
				else
					NCOFunction(lib.item.GetByID(ItemID).Link)
				end
			end
		end
	else
		lib.chat.error(this.Name..": invalid reward type: "..RewardData.Type)
	end
	
	return
end

function this.private.PrintFaction(FactionID,FactionData)
	this.private.Validate()
	
	--now check emissary status+option
	local NCOFunction = lib.chat.output.StoreDone	--NonCompletedOutputFunction
	if((option.ParagonEmissary == true) or (FactionData.EmissaryActive == true)) then
		NCOFunction = lib.chat.output.StoreTodo
	end
	
	--now check the faction status as a whole
	local Message = nil
	if(FactionData.SomethingMissing == true) then
		NCOFunction(FactionData.EmissaryMessage)
	else
		lib.chat.output.StoreCompleted(FactionData.Name)
	end
	
	--check if a paragon cache is waiting
	if(FactionData.RewardPending == true) then
		lib.chat.output.StoreTodo(YOU_EARNED_LABEL.." "..lib.item.GetByID(FactionData.BoxID).Link)
	end	
	
	--now loop rewards
	for ItemID,RewardData in pairs(FactionData.Rewards) do
		this.private.PrintReward(ItemID,RewardData,NCOFunction)
	end
	
	return
end

function this.private.Update()
	this.private.Validate()
	
	local out = lib.chat.output
	out.ClearBuffer()
	
	--character did not meet requirements
	if(this.private.Factions == nil) then
		return
	end
	
	--update all the prestored stuff
	--init journal + item links
	for FactionID,FactionData in pairs(this.private.Factions) do
		lib.faction.UpdateByID(FactionID)
		lib.quest.UpdateByID(FactionData.EmissaryID)
		lib.item.UpdateByID(FactionData.BoxID)
		
		for ItemID,RewardData in pairs(FactionData.Rewards) do
		
			--we always need the item
			lib.item.UpdateByID(ItemID)
			
			if(RewardData.Type == "Toy") then
				lib.journal.toy.UpdateByID(ItemID)
			elseif(RewardData.Type == "Pet") then
				lib.journal.pet.UpdateByID(RewardData.SpeciesID)
			elseif(RewardData.Type == "Recipe") then
				--nothing to do here
			else
				lib.chat.error(this.Name..": invalid reward type: "..RewardData.Type)
			end
		end
	end
	
	for FactionID,FactionData in pairs(this.private.Factions) do
		this.private.UpdateFaction(FactionID,FactionData)
		this.private.PrintFaction(FactionID,FactionData)
	end
	
	return
end

function this.CheckStatus()
	this.private.Validate()
	
	this.private.Update()
	if(lib.chat.output.GetNumLines() == 0) then
		return false
	end
	
	return true
end

function this.Script()
	this.private.Validate()
	
	this.private.Update()
	lib.chat.output.PrintModule(this.Name)
	
	return
end

mod[#mod+1] =
{
	CheckStatus	= this.CheckStatus,
	Text		= this.Name,
	Script		= this.Script
}
